OGRE-Next: Ogre::Codec Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Codec Class Referenceabstract
Core » General

Abstract class that defines a 'codec'. More...

`#include <OgreCodec.h>`

Inheritance diagram for Ogre::Codec:
[legend]

## Classes
class | CodecData

## Public Types
typedef SharedPtr< CodecData > | CodecDataPtr
typedef ConstMapIterator< CodecList > | CodecIterator
typedef std::pair< MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata.
enum | ValidationStatus { CodecValid , CodecInvalid , CodecUnknown }

## Public Member Functions
virtual | ~Codec ()
virtual DecodeResult | decode (DataStreamPtr &input) const =0
| Codes the data from the input chunk into the output chunk.
virtual DataStreamPtr | encode (MemoryDataStreamPtr &input, CodecDataPtr &pData) const =0
| Codes the data in the input stream and saves the result in the output stream.
virtual void | encodeToFile (MemoryDataStreamPtr &input, const String &outFileName, CodecDataPtr &pData) const =0
| Codes the data in the input chunk and saves the result in the output filename provided.
virtual String | getDataType () const =0
| Returns the type of the data that supported by this codec as a String.
virtual String | getType () const =0
| Returns the type of the codec as a String.
virtual bool | magicNumberMatch (const char *magicNumberPtr, size_t maxbytes) const
| Returns whether a magic number header matches this codec.
virtual String | magicNumberToFileExt (const char *magicNumberPtr, size_t maxbytes) const =0
| Maps a magic number header to a file extension, if this codec recognises it.
virtual ValidationStatus | validateMagicNumber (const char *magicNumberPtr, size_t maxbytes) const =0
| validateMagicNumber Returns whether a magic number header matches this codec.

## Static Public Member Functions
static Codec * | getCodec (char *magicNumberPtr, size_t maxbytes)
| Gets the codec that can handle the given 'magic' identifier.
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension.
static CodecIterator | getCodecIterator ()
| Gets the iterator for the registered codecs.
static StringVector | getExtensions ()
| Gets the file extension list for the registered codecs.
static bool | isCodecRegistered (const String &codecType)
| Return whether a codec is registered already.
static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database.
static void | unregisterCodec (Codec *pCodec)
| Unregisters a codec from the database.

## Detailed Description

Abstract class that defines a 'codec'.

Remarks
  A codec class works like a two-way filter for data - data entered on one end (the decode end) gets processed and transformed into easily usable data while data passed the other way around codes it back.

  The codec concept is a pretty generic one - you can easily understand how it can be used for images, sounds, archives, even compressed data.

## Member Typedef Documentation

## ◆ CodecDataPtr

typedef SharedPtr<CodecData> Ogre::Codec::CodecDataPtr

## ◆ CodecIterator

typedef ConstMapIterator<CodecList> Ogre::Codec::CodecIterator

## ◆ DecodeResult

typedef std::pair<MemoryDataStreamPtr, CodecDataPtr> Ogre::Codec::DecodeResult

Result of a decoding; both a decoded data stream and CodecData metadata.

## Member Enumeration Documentation

## ◆ ValidationStatus

enum Ogre::Codec::ValidationStatus

Enumerator
CodecValid |
CodecInvalid | Magic number says this codec can open this stream.
CodecUnknown | Magic number says this codec cannot open this stream. Cannot be verified. File may or may not open.

## Constructor & Destructor Documentation

## ◆ ~Codec()

virtual Ogre::Codec::~Codec | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ decode()

virtual DecodeResult Ogre::Codec::decode | ( | DataStreamPtr & | input | ) | const
| pure virtual

Codes the data from the input chunk into the output chunk.

Parameters

  input | Stream containing the encoded data

Implemented in Ogre::ASTCCodec, Ogre::DDSCodec2, Ogre::ETCCodec, Ogre::FreeImageCodec2, Ogre::OITDCodec, Ogre::PVRTCCodec, and Ogre::STBIImageCodec.

## ◆ encode()

virtual DataStreamPtr Ogre::Codec::encode | ( | MemoryDataStreamPtr & | input,
|  | CodecDataPtr & | pData ) const
| pure virtual

Codes the data in the input stream and saves the result in the output stream.

Implemented in Ogre::ASTCCodec, Ogre::DDSCodec2, Ogre::ETCCodec, Ogre::FreeImageCodec2, Ogre::OITDCodec, Ogre::PVRTCCodec, and Ogre::STBIImageCodec.

## ◆ encodeToFile()

virtual void Ogre::Codec::encodeToFile | ( | MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | CodecDataPtr & | pData ) const
| pure virtual

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters

  input | The input data
  outFileName | The filename to write to
  pData | Extra information to be passed to the codec (codec type specific)

Implemented in Ogre::ASTCCodec, Ogre::DDSCodec2, Ogre::ETCCodec, Ogre::FreeImageCodec2, Ogre::OITDCodec, Ogre::PVRTCCodec, and Ogre::STBIImageCodec.

## ◆ getCodec() [1/2]

Codec * Ogre::Codec::getCodec | ( | char * | magicNumberPtr,
|  | size_t | maxbytes )
| static

Gets the codec that can handle the given 'magic' identifier.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

## ◆ getCodec() [2/2]

Codec * Ogre::Codec::getCodec | ( | const String & | extension | ) |
| static

Gets the codec registered for the passed in file extension.

## ◆ getCodecIterator()

CodecIterator Ogre::Codec::getCodecIterator | ( |  | ) |
| inlinestatic

Gets the iterator for the registered codecs.

## ◆ getDataType()

virtual String Ogre::Codec::getDataType | ( |  | ) | const
| pure virtual

Returns the type of the data that supported by this codec as a String.

Implemented in Ogre::ImageCodec2.

## ◆ getExtensions()

StringVector Ogre::Codec::getExtensions | ( |  | ) |
| static

Gets the file extension list for the registered codecs.

## ◆ getType()

virtual String Ogre::Codec::getType | ( |  | ) | const
| pure virtual

Returns the type of the codec as a String.

Implemented in Ogre::ASTCCodec, Ogre::DDSCodec2, Ogre::ETCCodec, Ogre::FreeImageCodec2, Ogre::OITDCodec, Ogre::PVRTCCodec, and Ogre::STBIImageCodec.

Referenced by registerCodec(), and unregisterCodec().

## ◆ isCodecRegistered()

bool Ogre::Codec::isCodecRegistered | ( | const String & | codecType | ) |
| inlinestatic

Return whether a codec is registered already.

## ◆ magicNumberMatch()

virtual bool Ogre::Codec::magicNumberMatch | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes ) const
| inlinevirtual

Returns whether a magic number header matches this codec.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.

Remarks
  Deprecated. Use validateMagicNumber()

Parameters

  maxbytes | The number of bytes passed

References magicNumberMatch(), and magicNumberToFileExt().

Referenced by magicNumberMatch().

## ◆ magicNumberToFileExt()

virtual String Ogre::Codec::magicNumberToFileExt | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes ) const
| pure virtual

Maps a magic number header to a file extension, if this codec recognises it.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Returns
  A blank string if the magic number was unknown, or a file extension.

Implemented in Ogre::ASTCCodec, Ogre::DDSCodec2, Ogre::ETCCodec, Ogre::FreeImageCodec2, Ogre::OITDCodec, Ogre::PVRTCCodec, and Ogre::STBIImageCodec.

Referenced by magicNumberMatch().

## ◆ registerCodec()

void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) |
| inlinestatic

Registers a new codec in the database.

References Ogre::Exception::ERR_DUPLICATE_ITEM, getType(), and OGRE_EXCEPT.

## ◆ unregisterCodec()

void Ogre::Codec::unregisterCodec | ( | Codec * | pCodec | ) |
| inlinestatic

Unregisters a codec from the database.

References getType().

## ◆ validateMagicNumber()

virtual ValidationStatus Ogre::Codec::validateMagicNumber | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes ) const
| pure virtual

validateMagicNumber Returns whether a magic number header matches this codec.

At least 4 bytes must be supplied.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Returns
  Validation status.

Implemented in Ogre::ASTCCodec, Ogre::DDSCodec2, Ogre::ETCCodec, Ogre::FreeImageCodec2, Ogre::OITDCodec, Ogre::PVRTCCodec, and Ogre::STBIImageCodec.

The documentation for this class was generated from the following file:

- OgreCodec.h